package yeoupooh.scraper;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

/**
 * @author pooh
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class Scheduler extends Thread
{
    private String m_format = null;
    private String m_value = null;
    private boolean isActive = true;
    private ILogger m_logger = null;

    /**
     * Constructor for Scheduler.
     */
    public Scheduler()
    {
        m_logger = new DefaultLogger();
        try
        {
            ResourceBundle bundle = ResourceBundle.getBundle("scraper");
            m_format = bundle.getString("scheduler.format");
            m_value = bundle.getString("scheduler.value");
            m_logger = new DefaultLogger();
        }
        catch (MissingResourceException e)
        {
            m_logger.error("resource bundle not found.");
            m_format = "hh:mm:ss";
            m_value = "08:30:00";
        }

    }

    public void start()
    {
    	m_logger.info("Scraper Scheduler started.");
        m_logger.info("format=" + m_format);
        m_logger.info("value=" + m_value);
    }

    public void run()
    {
        while (isActive)
        {
            Date date = new Date();
            SimpleDateFormat dateFormat =
                new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
            SimpleDateFormat timeFormat = new SimpleDateFormat(m_format);
            String dateStr = dateFormat.format(date);
            String timeStr = timeFormat.format(date);
            if (new SimpleDateFormat("mm:ss").format(date).equals("00:00"))
            {
                m_logger.info(
                    dateStr + ", format=" + timeStr + ", value=" + m_value);
            }
            if (timeStr.equals(m_value))
            {
                isActive = false;
                m_logger.info("DING!!!");

                ScraperHelper app = new ScraperHelper();
                //                app.setScriptDir("scripts");
                //                app.setOutputDir("output");
                //                app.setMainSite("main.site");
                try
                {
                    app.scrapMainSite();

                }
                catch (Exception e)
                {
                    e.printStackTrace();
                }

                isActive = true;
            } // end of if
            try
            {
                Thread.sleep(1000);
            }
            catch (InterruptedException e)
            {
                e.printStackTrace();
            }
        } // end of while
    }

    /**
     * Sets the logger.
     * @param logger The logger to set
     */
    public void setLogger(ILogger logger)
    {
        m_logger = logger;
    }

    /**
     * Returns the format.
     * @return String
     */
    public String getFormat()
    {
        return m_format;
    }

    /**
     * Returns the value.
     * @return String
     */
    public String getValue()
    {
        return m_value;
    }

    /**
     * Sets the format.
     * @param format The format to set
     */
    public void setFormat(String format)
    {
        m_format = format;
    }

    /**
     * Sets the value.
     * @param value The value to set
     */
    public void setValue(String value)
    {
        m_value = value;
    }

    public static void main(String args[])
    {
        Thread thread = new Thread(new Scheduler());
        thread.start();
    }

}
