package yeoupooh.scraper;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.PrintStream;

/**
 * @author pooh
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class ScrapablePageBuilder
{
    private BufferedReader m_reader;
    private PrintStream m_print;
    private StringBuffer m_buffer;

    public ScrapablePageBuilder(BufferedReader reader, PrintStream print)
    {
        m_reader = reader;
        m_print = print;
        m_buffer = new StringBuffer();
    }

    public void build() throws IOException
    {
        String line = m_reader.readLine();
        while (line != null)
        {
            System.out.println(line);
            //m_print.println(line);
            m_buffer.append(line);
            //parse(line, m_print);
            line = m_reader.readLine();
        }

        // parse
        String bufferStr = m_buffer.toString();
        while (bufferStr != null)
        {
            int indexOfScriptStart = bufferStr.toLowerCase().indexOf("<script");
            int indexOfRemarkStart = bufferStr.indexOf("<!--");
            int indexOfTagStart = bufferStr.indexOf("<");

            if (indexOfScriptStart > -1
                && indexOfScriptStart == indexOfTagStart)
            {
                //m_print.println("--- prcess <script> ----");
                // ex) ...<script>... </script>
                if (indexOfScriptStart > 0)
                {
                    // scrap text
                    m_print.println(bufferStr.substring(0, indexOfScriptStart));

                    // decrease buffer
                    bufferStr = bufferStr.substring(indexOfScriptStart);
                }
                int indexOfScriptEnd =
                    bufferStr.toLowerCase().indexOf("</script>");
                // scrap <script ... > to </script>
                m_print.println(bufferStr.substring(0, indexOfScriptEnd + 9));

                // decrease buffer
                bufferStr = bufferStr.substring(indexOfScriptEnd + 9);
            }
            else if (
                indexOfRemarkStart > -1
                    && indexOfRemarkStart == indexOfTagStart)
            {
                //m_print.println("--- prcess <!-- ----");
                // ex) ...<!-- ... -->
                if (indexOfRemarkStart > 0)
                {
                    // scrap text
                    m_print.println(bufferStr.substring(0, indexOfRemarkStart));

                    // decrease buffer
                    bufferStr = bufferStr.substring(indexOfRemarkStart);
                }
                int indexOfRemarkEnd = bufferStr.indexOf("-->");
                // scrap <!-- to -->
                m_print.println(bufferStr.substring(0, indexOfRemarkEnd + 3));

                // decrease buffer
                bufferStr = bufferStr.substring(indexOfRemarkEnd + 3);
            }
            else if (indexOfTagStart > -1)
            {
                //m_print.println("--- prcess < ----");
                // ex) ...<some ... >
                if (indexOfTagStart > 0)
                {
                    // scrap text
                    m_print.println(bufferStr.substring(0, indexOfTagStart));

                    // decrease buffer
                    bufferStr = bufferStr.substring(indexOfTagStart);
                }
                int indexOfTagEnd = bufferStr.indexOf(">");
                // scrap <some ... >
                m_print.println(bufferStr.substring(0, indexOfTagEnd + 1));

                // decrease buffer
                bufferStr = bufferStr.substring(indexOfTagEnd + 1);
            }
            // ex) ...(no tags)...
            else
            {
                // scrap <some ... >
                m_print.println(bufferStr);

                // decrease buffer
                bufferStr = null;
            }
        }
        //m_print.println(m_buffer.toString());
    }

    public void parse(String src, PrintStream print)
    {

        // <script>  뿡 ! ex) if (a>b) 
        while (true)
        {
            if (src.indexOf("<") > -1)
            {
                if (src.indexOf(">") > -1)
                {
                    System.out.println("src=" + src);
                    System.out.println("<=" + src.indexOf("<"));
                    System.out.println(">=" + src.indexOf(">"));
                    print.println(
                        src.substring(src.indexOf("<"), src.indexOf(">")));
                    src = src.substring(src.indexOf(">") + 1);
                }
            }
            else
            {
                break;
            }
        }
    }
}
