package yeoupooh.scraper;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

/**
 * @author pooh
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class ScraperLauncher implements SelectionListener
{
    private String m_scraperHome = null;
    private ScraperHelper m_helper = null;

    private Display display = new Display();
    private Shell shell = new Shell(display);
    private static final String BUTTON_RUNALL = " ϱ";
    private static final String BUTTON_RUN = "ϱ";
    private static final String BUTTON_HELP = "";
    private static final String BUTTON_EXIT = "";
    private Button buttonRunAll = null;
    private Button buttonRun = null;
    private Button buttonHelp = null;
    private Button buttonExit = null;
    private List listSite = null;
    private Text m_textLog = null;

    public ScraperLauncher()
    {
        m_scraperHome = System.getProperty("scraper.home", "..");
        m_helper = new ScraperHelper();
        m_helper.setScriptDir(m_scraperHome + "/scripts");
        m_helper.setOutputDir(m_scraperHome + "/output");
    }

    public void buildUI()
    {
        shell.setText(
            "Scraper Launcher (E:v"
                + m_helper.getScraper().getEngineVersion()
                + ", S:v"
                + m_helper.getScraper().getScriptVersion()
                + ")");
        try
        {
            shell.setImage(
                new Image(display, m_scraperHome + "/images/TOpooh6.ico"));
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }

        // grid layout
        GridLayout gridLayout = new GridLayout();
        gridLayout.numColumns = 2;
        shell.setLayout(gridLayout);

        // list box
        listSite = new List(shell, SWT.DEFAULT);
        GridData gridDataList = new GridData();
        gridDataList.widthHint = 200;
        gridDataList.verticalAlignment = GridData.FILL;
        gridDataList.verticalSpan = 4;
        listSite.setLayoutData(gridDataList);
        listSite.addSelectionListener(this);

        // add file list
        String[] siteFilenames = m_helper.getSiteFileList();
        if (siteFilenames != null)
        {
            for (int i = 0; i < siteFilenames.length; i++)
            {
                String filename = siteFilenames[i];
                listSite.add(filename);
            }
        }
        // run all button
        buttonRunAll = new Button(shell, SWT.PUSH);
        buttonRunAll.setText(BUTTON_RUNALL);
        GridData gdAllRun = new GridData();
        gdAllRun.widthHint = 100;
        gdAllRun.heightHint = 30;
        buttonRunAll.setLayoutData(gdAllRun);
        buttonRunAll.addSelectionListener(this);

        // run button
        buttonRun = new Button(shell, SWT.PUSH);
        buttonRun.setText(BUTTON_RUN);
        GridData gdRun = new GridData();
        gdRun.horizontalAlignment = GridData.FILL;
        gdRun.widthHint = 100;
        gdRun.heightHint = 30;
        //        gridData1.horizontalSpan = 2;
        buttonRun.setLayoutData(gdRun);
        buttonRun.addSelectionListener(this);

        // help button
        buttonHelp = new Button(shell, SWT.PUSH);
        buttonHelp.setText(BUTTON_HELP);
        GridData gdHelp = new GridData();
        gdHelp.widthHint = 100;
        gdHelp.heightHint = 30;
        buttonHelp.setLayoutData(gdHelp);
        buttonHelp.addSelectionListener(this);

        // exit button
        buttonExit = new Button(shell, SWT.PUSH);
        buttonExit.setText(BUTTON_EXIT);
        GridData gdExit = new GridData();
        gdExit.widthHint = 100;
        gdExit.heightHint = 30;
        buttonExit.setLayoutData(gdExit);
        buttonExit.addSelectionListener(this);

        // log text
        ScrolledComposite scrolledText =
            new ScrolledComposite(
                shell,
                SWT.H_SCROLL | SWT.V_SCROLL | SWT.BORDER);
        GridData gdScrollLog = new GridData();
        gdScrollLog.horizontalSpan = 2;
        gdScrollLog.heightHint = 50;
        gdScrollLog.widthHint = 300;
        scrolledText.setLayoutData(gdScrollLog);

        Composite composite = new Composite(scrolledText, SWT.NONE);
        scrolledText.setContent(composite);
        FillLayout layout = new FillLayout();
        //RowLayout layout = new RowLayout();
        //GridLayout layout = new GridLayout();
        //layout.numColumns = 1;
        scrolledText.setExpandHorizontal(true);
        scrolledText.setExpandVertical(true);
        scrolledText.setMinSize(
            composite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
        composite.setLayout(layout);

        m_textLog =
            new Text(composite, SWT.MULTI | SWT.READ_ONLY | SWT.V_SCROLL);
        m_textLog.append("Welcome.\r\n");
        m_textLog.setBackground(new Color(display, 0xFF, 0xFF, 0xFF));
        m_helper.setScraperLogger(new ScraperLauncherLogger(m_textLog));
        /*
                GridData gdLog = new GridData();
                gdLog.heightHint = 50;
                gdLog.widthHint = 300;
                m_textLog.setLayoutData(gdLog);
        */
        composite.setSize(composite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
        //scrolledText.setContent(m_textLog);

        shell.pack();
        shell.open();
    }

    public void run()
    {
        buildUI();

        while (!shell.isDisposed())
        {
            if (!display.readAndDispatch())
                display.sleep();
        }
        display.dispose();
    }

    public static void main(String[] args)
    {
        ScraperLauncher app = new ScraperLauncher();
        app.run();
    }
    /**
     * @see org.eclipse.swt.events.SelectionListener#widgetDefaultSelected(SelectionEvent)
     */
    public void widgetDefaultSelected(SelectionEvent arg0)
    {
    }

    /**
     * @see org.eclipse.swt.events.SelectionListener#widgetSelected(SelectionEvent)
     */
    public void widgetSelected(SelectionEvent event)
    {
        if (event.getSource().equals(buttonExit))
        {
            System.exit(1);
        }
        else if (event.getSource().equals(buttonRunAll))
        {
            try
            {
                m_helper.scrapAllSite();
            }
            catch (Exception e)
            {
                e.printStackTrace();
            }
        }
        else if (event.getSource().equals(buttonRun))
        {
            try
            {
                if (listSite.getSelectionIndex() > -1)
                {
                    m_helper.scrapSite(
                        listSite.getItem(listSite.getSelectionIndex()));
                }
            }
            catch (Exception e)
            {
                e.printStackTrace();
            }
        }
        else if (event.getSource().equals(buttonHelp))
        {
            System.out.println("help");
        }
        else if (event.getSource().equals(listSite))
        {
            System.out.println("bingo!!");
        }
    }

}
