package yeoupooh.scraper;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * @author pooh
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class SiteFile
{
    private String m_version = null;
    private String m_description = null;
    private String m_url = null;
    private String m_scriptFilename = null;
    private String m_outputFilename = null;

    /**
     * Constructor for SiteFile.
     */
    public SiteFile()
    {
        super();
    }

    public void loadFromFile(String siteFilename) throws IOException
    {
        // open stream
        BufferedReader readerScript =
            new BufferedReader(
                new InputStreamReader(
                    new FileInputStream(new File(siteFilename))));

        // read site
        m_version = readerScript.readLine();
        m_description = readerScript.readLine();
        m_url = readerScript.readLine();
        m_scriptFilename = readerScript.readLine();
        m_outputFilename = readerScript.readLine();

        // close stream
        readerScript.close();
    }

    /**
     * Returns the outputFilename.
     * @return String
     */
    public String getOutputFilename()
    {
        return m_outputFilename;
    }

    /**
     * Returns the scriptFilename.
     * @return String
     */
    public String getScriptFilename()
    {
        return m_scriptFilename;
    }

    /**
     * Returns the url.
     * @return String
     */
    public String getUrl()
    {
        return m_url;
    }

    /**
     * Returns the version.
     * @return String
     */
    public String getVersion()
    {
        return m_version;
    }

    /**
     * Sets the outputFilename.
     * @param outputFilename The outputFilename to set
     */
    public void setOutputFilename(String outputFilename)
    {
        m_outputFilename = outputFilename;
    }

    /**
     * Sets the scriptFilename.
     * @param scriptFilename The scriptFilename to set
     */
    public void setScriptFilename(String scriptFilename)
    {
        m_scriptFilename = scriptFilename;
    }

    /**
     * Sets the url.
     * @param url The url to set
     */
    public void setUrl(String url)
    {
        m_url = url;
    }

    /**
     * Sets the version.
     * @param version The version to set
     */
    public void setVersion(String version)
    {
        m_version = version;
    }

    /**
     * Returns the description.
     * @return String
     */
    public String getDescription()
    {
        return m_description;
    }

    /**
     * Sets the description.
     * @param description The description to set
     */
    public void setDescription(String description)
    {
        m_description = description;
    }

}
